summaryrefslogtreecommitdiff
path: root/scripts/xflock4
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/xflock4')
-rw-r--r--scripts/xflock454
1 files changed, 54 insertions, 0 deletions
diff --git a/scripts/xflock4 b/scripts/xflock4
new file mode 100644
index 0000000..7ebb423
--- /dev/null
+++ b/scripts/xflock4
@@ -0,0 +1,54 @@
+#!/bin/sh
+#
+# xfce4
+#
+# Copyright (C) 1999, 2003 Olivier Fourdan (fourdan@xfce.org)
+# Copyright (C) 2011 Guido Berhoerster (guido+xfce.org@berhoerster.name)
+# Copyright (C) 2011 Jarno Suni (8@iki.fi)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+
+# First test for the command set in the session's xfconf channel
+LOCK_CMD=$(xfconf-query -c xfce4-session -p /general/LockCommand)
+
+# Lock by xscreensaver or gnome-screensaver, if a respective daemon is running
+for lock_cmd in \
+ "$LOCK_CMD" \
+ "xfce4-screensaver-command --lock" \
+ "xscreensaver-command -lock" \
+ "gnome-screensaver-command --lock"
+do
+ if [ ! -z "$lock_cmd" ]; then
+ $lock_cmd >/dev/null 2>&1 && exit
+ fi
+done
+
+# else run another access locking utility, if installed
+for lock_cmd in \
+ "xlock -mode blank" \
+ "slock"
+ do
+ set -- $lock_cmd
+ if command -v -- $1 >/dev/null 2>&1; then
+ $lock_cmd >/dev/null 2>&1 &
+ # turn off display backlight:
+ xset dpms force off
+ exit
+ fi
+done
+
+# else access locking failed
+exit 1